<?php
/*
Plugin Name: Moneybookers Merchant Gateway For eShop.
Plugin URI: http://www.skrilleshopplugin.com/
Description: This plugin is called as SKRILLESHOP WORDPRESS PLUGIN(formerly Moneybookers Merchant Gateway for eShop) which will give a hassle free Payment solution to all eShop store merchants and Skrill merchants using WP platform.
Version: 0.0.2
Author: L.Ch.Rajkumar 
Author URI: http://www.twitter.com/lchrajkumar/

    Copyright 2013 L.Ch.Rajkumar  (email : skrilleshopplugin@gmail.com, hr.techtransformerz@gmail.com, l.ch.rajkumar@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
register_activation_hook(__FILE__,'eshopmoneybookers_activate');
function eshopmoneybookers_activate(){
	/*
	* Activation routines
	*/
	global $wpdb;
	$opts=get_option('active_plugins');
	$eshopthere=false;
	foreach($opts as $opt){
		if($opt=='eshop/eshop.php')
			$eshopthere=true;
	}
	if($eshopthere==false){
		deactivate_plugins('moneybookers-mg.php'); //Deactivate ourself
		wp_die(__('ERROR! eShop is not active.','eshop')); 
	}
	/*
	* insert email template for use with this merchant gateway, if 151 is changed, then ipn.php needs amending as well 
	*/
	$table = $wpdb->prefix ."eshop_emails";
	$esubject=__('Your order from ','eshop').get_bloginfo('name');
	$wpdb->query("INSERT INTO ".$table." (id,emailType,emailSubject) VALUES ('151','".__('Automatic Moneybookers email','eshop')."','$esubject')"); 
	
}
add_action('eshop_setting_merchant_load','eshopmgpage');
function eshopmgpage($thist){
	/*
	* adding the meta box for this gateway
	*/
	add_meta_box('eshop-m-moneybookers', __('Moneybookers','eshop'), 'moneybookers_box', $thist->pagehook, 'normal', 'core');
}

function moneybookers_box($eshopoptions) {
	/*
	* the meta box content, obviously you have to set up the required fields for your gateway here
	*/
	if(isset($eshopoptions['moneybookers'])){
		$eshopmoneybookers = $eshopoptions['moneybookers']; 
	}else{
		$eshopmoneybookers['email']='';
		$eshopmoneybookers['desc']='';
                $eshopmoneybookers['confirmation']='';
                $eshopmoneybookers['paystatus']='';
				$eshopmoneybookers['newversion']='';
               
	}
	//add the image
	$eshopmerchantimgpath=WP_PLUGIN_DIR.'/moneybookers-mg/moneybookers.png';
	$eshopmerchantimgurl=WP_PLUGIN_URL.'/moneybookers-mg/moneybookers.png';
	$dims[3]='';
	if(file_exists($eshopmerchantimgpath))
	$dims=getimagesize($eshopmerchantimgpath);
	echo '<fieldset>';
	echo '<p class="eshopgatmoneybookers"><img src="'.$eshopmerchantimgurl.'" '.$dims[3].' alt="moneybookers" title="moneybookers" /></p>'."\n";
?>
	<p class="cbox"><input id="eshop_methodmoneybookers" name="eshop_method[]" type="checkbox" value="moneybookers"<?php if(in_array('moneybookers',(array)$eshopoptions['method'])) echo ' checked="checked"'; ?> /><label for="eshop_methodmoneybookers" class="eshopmethod"><?php _e('Accept payment by Moneybookers','eshop'); ?></label></p>
	<label for="eshop_moneybookersnewversion"><b style="font-size:14px;"><?php _e('Want a new version for this plugin, then go to <a href="http://www.skrilleshopplugin.com/shop/" target="_blank">Our Skrill eShop SHOP</a> and grab new version for just $6.25 only.','eshop');?></b></label><br />
	<label for="eshop_moneybookersemail"><?php _e('Email address','eshop'); ?></label><input id="eshop_moneybookersemail" name="moneybookers[email]" type="text" value="<?php echo $eshopmoneybookers['email']; ?>" size="30" maxlength="50" /><br />
	<label for="eshop_moneybookersdesc"><?php _e('Moneybookers Cart Description','eshop'); ?></label><input id="eshop_moneybookersdesc" name="moneybookers[desc]" type="text" value="<?php echo $eshopmoneybookers['desc']; ?>" size="60" /><br />
    <label for="eshop_moneybookersconf"><?php _e('Your Confirmation Note For Buyers After Making Their Purchase.', 'eshop');?></label><input id="eshop_moneybookersconf" name="moneybookers[confirmation]" type="text" value="<?php echo $eshopmoneybookers['confirmation'];?>" size="30" maxlength="100"/><br/>
    <label for="eshop_moneybookerspaystatus"><?php _e('Your Merchant E-Mail To Recieve The Payment Status.','eshop');?></label><input id="eshop_moneybookerspaystatus" name="moneybookers[paystatus]" type="text" value="<?php echo $eshopmoneybookers['paystatus'];?>" size="32" maxlength="100"/>
    </fieldset>
<?php
}

add_filter('eshop_setting_merchant_save','moneybookerssave',10,2);
function moneybookerssave($eshopoptions,$posted){
	/*
	* save routine for the fields you added above
	*/
	global $wpdb;
	$moneybookerspost['email']=$wpdb->escape($posted['moneybookers']['email']);
	$moneybookerspost['desc']=$wpdb->escape($posted['moneybookers']['desc']);
        $moneybookerspost['confirmation']=$wpdb->escape($posted['moneybookers']['confirmation']);
        $moneybookerspost['paystatus']=$wpdb->escape($posted['moneybookers']['paystatus']);
	$eshopoptions['moneybookers']=$moneybookerspost;
	return $eshopoptions;
}

add_action('eshop_include_mg_ipn','eshopmoneybookers');
function eshopmoneybookers($eshopaction){
	/*
	* adding the necessary link for the instant payment notification of your gateway
	*/
	if($eshopaction=='moneybookersipn'){
		include_once WP_PLUGIN_DIR.'/moneybookers-mg/ipn.php';
	}
}

add_filter('eshop_merchant_img_moneybookers','moneybookersimg');
function moneybookersimg($array){
	/*
	* adding the image for this gateway, for use on the front end of the site
	*/
	$array['path']=WP_PLUGIN_DIR.'/moneybookers-mg/moneybookers.png';
	$array['url']=WP_PLUGIN_URL.'/moneybookers-mg/moneybookers.png';
	return $array;
}
add_filter('eshop_mg_inc_path','moneybookerspath',10,2);
function moneybookerspath($path,$paymentmethod){
	/*
	* adding another necessary link for the instant payment notification of your gateway
	*/
	if($paymentmethod=='moneybookers')
		return WP_PLUGIN_DIR.'/moneybookers-mg/ipn.php';
	return $path;
}
add_filter('eshop_mg_inc_idx_path','moneybookersidxpath',10,2);
function moneybookersidxpath($path,$paymentmethod){
	/*
	* adding the necessary link to the class for this gateway
	*/
	if($paymentmethod=='moneybookers')
                return WP_PLUGIN_DIR.'/moneybookers-mg/moneybookers-mg.php';
		return WP_PLUGIN_DIR.'/moneybookers-mg/moneybookers-class.php';
	return $path;
}
//message on fail.
add_filter('eshop_show_success', 'eshop_moneybookers_return_fail',10,3);
function eshop_moneybookers_return_fail($echo, $eshopaction, $postit){
	/*
	* failed payment, you can add in details for this, will need tweaking for your gateway
	*/
	//these are the successful codes, all others fail
	$moneybookersrescodes=array('00','08','10','11','16');
	if($eshopaction=='moneybookersipn'){
		if($postit['moneybookersTrxnStatus']=='False' && !in_array($postit['moneybookersresponseCode'],$moneybookersrescodes))
			$echo .= '<p>There was a problem with your order, please contact admin@ ... quoting Error Code '.$postit['moneybookersresponseCode']."</p>\n";
	}
	return $echo;
}
?>